Attribute VB_Name = "Commun"
Option Explicit

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Type BrowseInfo
  hWndOwner As Long
  pIDLRoot As Long
  pszDisplayName As Long
  lpszTitle As Long
  ulFlags As Long
  lpfnCallback As Long
  lParam As Long
  iImage As Long
End Type
Const BIF_RETURNONLYFSDIRS = 1
Const MAX_PATH = 260

Function SelectFolder(WinParent As Long) As String
  'V 1.0
  'Paramtres : Le handle de la fentre parent
  'Retour : Le rpertoire slectionn ou vide si annul
  Dim Posit As Integer
  Dim ReturnList As Long
  Dim ReturnPath As String
  Dim MyBrowseInfo As BrowseInfo
  'on dfinit ici la structure BrowseInfo
  MyBrowseInfo.hWndOwner = WinParent
  'Slection obligatoire d'un rpertoire
  MyBrowseInfo.ulFlags = BIF_RETURNONLYFSDIRS
  'Afficher la boite de slection
  ReturnList = SHBrowseForFolder(MyBrowseInfo)
  If ReturnList Then
    'Initialiser la chaine
    ReturnPath = String$(MAX_PATH, 0)
    'Obtenir le Path  partir de la liste retourne
    Call SHGetPathFromIDList(ReturnList, ReturnPath)
    Posit = InStr(ReturnPath, vbNullChar)
    If Posit Then
      ReturnPath = Left$(ReturnPath, Posit - 1)
    End If
  End If
  SelectFolder = ReturnPath
End Function
